!-------------------------------------------------------------------------------
! Description:
!
!   Deallocate components of a model_type structure.
!
! Copyright:
!
!    This software was developed within the context of the EUMETSAT Satellite
!    Application Facility on Numerical Weather Prediction (NWP SAF), under the
!    Cooperation Agreement dated 29 June 2011, between EUMETSAT and the
!    Met Office, UK, by one or more partners within the NWP SAF. The partners
!    in the NWP SAF are the Met Office, ECMWF, KNMI and MeteoFrance.
!
!    Copyright 2017, EUMETSAT, All Rights Reserved.
!
!-------------------------------------------------------------------------------

subroutine radsim_dealloc_model(model)

use radsim_mod_types, only : &
  model_type

implicit none

type(model_type), intent(inout) :: model
model % nprofs = 0
model % nlevels = 0
if ( associated(model % validity_time ) ) deallocate(model % validity_time)
if ( associated(model % lsm)        ) deallocate(model % lsm)
if ( associated(model % zsurf)      ) deallocate(model % zsurf)
if ( associated(model % seaice)     ) deallocate(model % seaice)
if ( associated(model % pstar)      ) deallocate(model % pstar)
if ( associated(model % t2)         ) deallocate(model % t2)
if ( associated(model % td2)        ) deallocate(model % td2)
if ( associated(model % q2)         ) deallocate(model % q2)
if ( associated(model % rh2)        ) deallocate(model % rh2)
if ( associated(model % tskin)      ) deallocate(model % tskin)
if ( associated(model % u10)        ) deallocate(model % u10)
if ( associated(model % v10)        ) deallocate(model % v10)
if ( associated(model % z)          ) deallocate(model % z)
if ( associated(model % p)          ) deallocate(model % p)
if ( associated(model % ph)         ) deallocate(model % ph)
if ( associated(model % t)          ) deallocate(model % t)
if ( associated(model % theta)      ) deallocate(model % theta)
if ( associated(model % q)          ) deallocate(model % q)
if ( associated(model % rh)         ) deallocate(model % rh)
if ( associated(model % clw)        ) deallocate(model % clw)
if ( associated(model % ciw)        ) deallocate(model % ciw)
if ( associated(model % rain)       ) deallocate(model % rain)
if ( associated(model % snow)       ) deallocate(model % snow)
if ( associated(model % cfrac)      ) deallocate(model % cfrac)
if ( associated(model % cfrac_liq)  ) deallocate(model % cfrac_liq)
if ( associated(model % cfrac_ice)  ) deallocate(model % cfrac_ice)
if ( associated(model % cfrac_conv) ) deallocate(model % cfrac_conv)
if ( associated(model % conv_cloud) ) deallocate(model % conv_cloud)
if ( associated(model % conv_inc)   ) deallocate(model % conv_inc)
if ( associated(model % o3)         ) deallocate(model % o3)
if ( associated(model % co2)        ) deallocate(model % co2)
if ( associated(model % n2o)        ) deallocate(model % n2o)
if ( associated(model % co)         ) deallocate(model % co)
if ( associated(model % ch4)        ) deallocate(model % ch4)

end subroutine radsim_dealloc_model
